=begin
#Yousign API Swagger

#For your information, the Yousign API documentation is available at https://dev.yousign.com/

OpenAPI spec version: 2.1
Contact: support@yousign.fr
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module YousignClient
  class AuthenticationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Find an Authentication by ID
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationEmailOutput]
    def authentications_email_id_get(id, opts = {})
      data, _status_code, _headers = authentications_email_id_get_with_http_info(id, opts)
      data
    end

    # Find an Authentication by ID
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationEmailOutput, Fixnum, Hash)>] AuthenticationEmailOutput data, response status code and response headers
    def authentications_email_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationsApi.authentications_email_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AuthenticationsApi.authentications_email_id_get"
      end
      # resource path
      local_var_path = '/authentications/email/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationEmailOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationsApi#authentications_email_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an Email Authentication
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationEmailOutput]
    def authentications_email_id_put(id, body, opts = {})
      data, _status_code, _headers = authentications_email_id_put_with_http_info(id, body, opts)
      data
    end

    # Update an Email Authentication
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationEmailOutput, Fixnum, Hash)>] AuthenticationEmailOutput data, response status code and response headers
    def authentications_email_id_put_with_http_info(id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationsApi.authentications_email_id_put ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AuthenticationsApi.authentications_email_id_put"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AuthenticationsApi.authentications_email_id_put"
      end
      # resource path
      local_var_path = '/authentications/email/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationEmailOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationsApi#authentications_email_id_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get an Authentication
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationInweboOutput]
    def authentications_inwebo_id_get(id, opts = {})
      data, _status_code, _headers = authentications_inwebo_id_get_with_http_info(id, opts)
      data
    end

    # Get an Authentication
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationInweboOutput, Fixnum, Hash)>] AuthenticationInweboOutput data, response status code and response headers
    def authentications_inwebo_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationsApi.authentications_inwebo_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AuthenticationsApi.authentications_inwebo_id_get"
      end
      # resource path
      local_var_path = '/authentications/inwebo/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationInweboOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationsApi#authentications_inwebo_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an inwebo Authentication
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationInweboOutput]
    def authentications_inwebo_id_put(id, body, opts = {})
      data, _status_code, _headers = authentications_inwebo_id_put_with_http_info(id, body, opts)
      data
    end

    # Update an inwebo Authentication
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationInweboOutput, Fixnum, Hash)>] AuthenticationInweboOutput data, response status code and response headers
    def authentications_inwebo_id_put_with_http_info(id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationsApi.authentications_inwebo_id_put ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AuthenticationsApi.authentications_inwebo_id_put"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AuthenticationsApi.authentications_inwebo_id_put"
      end
      # resource path
      local_var_path = '/authentications/inwebo/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationInweboOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationsApi#authentications_inwebo_id_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Find an Authentication by ID
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationSmsOutput]
    def authentications_sms_id_get(id, opts = {})
      data, _status_code, _headers = authentications_sms_id_get_with_http_info(id, opts)
      data
    end

    # Find an Authentication by ID
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationSmsOutput, Fixnum, Hash)>] AuthenticationSmsOutput data, response status code and response headers
    def authentications_sms_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationsApi.authentications_sms_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AuthenticationsApi.authentications_sms_id_get"
      end
      # resource path
      local_var_path = '/authentications/sms/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationSmsOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationsApi#authentications_sms_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update an SMS Authentication
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [AuthenticationSmsOutput]
    def authentications_sms_id_put(id, body, opts = {})
      data, _status_code, _headers = authentications_sms_id_put_with_http_info(id, body, opts)
      data
    end

    # Update an SMS Authentication
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AuthenticationSmsOutput, Fixnum, Hash)>] AuthenticationSmsOutput data, response status code and response headers
    def authentications_sms_id_put_with_http_info(id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: AuthenticationsApi.authentications_sms_id_put ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling AuthenticationsApi.authentications_sms_id_put"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling AuthenticationsApi.authentications_sms_id_put"
      end
      # resource path
      local_var_path = '/authentications/sms/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AuthenticationSmsOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AuthenticationsApi#authentications_sms_id_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
