=begin
#Yousign API Swagger

#For your information, the Yousign API documentation is available at https://dev.yousign.com/

OpenAPI spec version: 2.1
Contact: support@yousign.fr
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module YousignClient
  class FileObjectsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete a File Object
    # Delete a File Object
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def file_objects_id_delete(id, opts = {})
      file_objects_id_delete_with_http_info(id, opts)
      nil
    end

    # Delete a File Object
    # Delete a File Object
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def file_objects_id_delete_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FileObjectsApi.file_objects_id_delete ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FileObjectsApi.file_objects_id_delete"
      end
      # resource path
      local_var_path = '/file_objects/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FileObjectsApi#file_objects_id_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Find a File Object by ID
    # Get a File Object
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [FileObjectOutput]
    def file_objects_id_get(id, opts = {})
      data, _status_code, _headers = file_objects_id_get_with_http_info(id, opts)
      data
    end

    # Find a File Object by ID
    # Get a File Object
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileObjectOutput, Fixnum, Hash)>] FileObjectOutput data, response status code and response headers
    def file_objects_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FileObjectsApi.file_objects_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FileObjectsApi.file_objects_id_get"
      end
      # resource path
      local_var_path = '/file_objects/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileObjectOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FileObjectsApi#file_objects_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update a File Object
    # Update a File Object
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [FileObjectOutput]
    def file_objects_id_put(id, body, opts = {})
      data, _status_code, _headers = file_objects_id_put_with_http_info(id, body, opts)
      data
    end

    # Update a File Object
    # Update a File Object
    # @param id 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileObjectOutput, Fixnum, Hash)>] FileObjectOutput data, response status code and response headers
    def file_objects_id_put_with_http_info(id, body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FileObjectsApi.file_objects_id_put ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FileObjectsApi.file_objects_id_put"
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling FileObjectsApi.file_objects_id_put"
      end
      # resource path
      local_var_path = '/file_objects/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileObjectOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FileObjectsApi#file_objects_id_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a new File Object
    # Create a new fileObject
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [FileObjectOutput]
    def file_objects_post(body, opts = {})
      data, _status_code, _headers = file_objects_post_with_http_info(body, opts)
      data
    end

    # Create a new File Object
    # Create a new fileObject
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileObjectOutput, Fixnum, Hash)>] FileObjectOutput data, response status code and response headers
    def file_objects_post_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FileObjectsApi.file_objects_post ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling FileObjectsApi.file_objects_post"
      end
      # resource path
      local_var_path = '/file_objects'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileObjectOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FileObjectsApi#file_objects_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
