=begin
#Yousign API Swagger

#For your information, the Yousign API documentation is available at https://dev.yousign.com/

OpenAPI spec version: 2.1
Contact: support@yousign.fr
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module YousignClient
  class FilesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Download a File
    # Used to get the base64 content of a file
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [String]
    def files_id_download_get(id, opts = {})
      data, _status_code, _headers = files_id_download_get_with_http_info(id, opts)
      data
    end

    # Download a File
    # Used to get the base64 content of a file
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def files_id_download_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FilesApi.files_id_download_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FilesApi.files_id_download_get"
      end
      # resource path
      local_var_path = '/files/{id}/download'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FilesApi#files_id_download_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Duplicate a File
    # Duplicate a file. It will be create a clone of this file, with a new ID.
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [FileOutput]
    def files_id_duplicate_post(id, opts = {})
      data, _status_code, _headers = files_id_duplicate_post_with_http_info(id, opts)
      data
    end

    # Duplicate a File
    # Duplicate a file. It will be create a clone of this file, with a new ID.
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileOutput, Fixnum, Hash)>] FileOutput data, response status code and response headers
    def files_id_duplicate_post_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FilesApi.files_id_duplicate_post ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FilesApi.files_id_duplicate_post"
      end
      # resource path
      local_var_path = '/files/{id}/duplicate'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FilesApi#files_id_duplicate_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Find a File by ID
    # Returns all the information regarding the File but without its content (for performance issue).
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [FileOutput]
    def files_id_get(id, opts = {})
      data, _status_code, _headers = files_id_get_with_http_info(id, opts)
      data
    end

    # Find a File by ID
    # Returns all the information regarding the File but without its content (for performance issue).
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileOutput, Fixnum, Hash)>] FileOutput data, response status code and response headers
    def files_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FilesApi.files_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling FilesApi.files_id_get"
      end
      # resource path
      local_var_path = '/files/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FilesApi#files_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a new File
    # Used to upload a file in base64 on our platform
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [FileOutput]
    def files_post(body, opts = {})
      data, _status_code, _headers = files_post_with_http_info(body, opts)
      data
    end

    # Create a new File
    # Used to upload a file in base64 on our platform
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(FileOutput, Fixnum, Hash)>] FileOutput data, response status code and response headers
    def files_post_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: FilesApi.files_post ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling FilesApi.files_post"
      end
      # resource path
      local_var_path = '/files'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'FileOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FilesApi#files_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
