=begin
#Yousign API Swagger

#For your information, the Yousign API documentation is available at https://dev.yousign.com/

OpenAPI spec version: 2.1
Contact: support@yousign.fr
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.14

=end

require 'uri'

module YousignClient
  class OperationsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Find an Operation by ID
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [OperationOutput]
    def operations_id_get(id, opts = {})
      data, _status_code, _headers = operations_id_get_with_http_info(id, opts)
      data
    end

    # Find an Operation by ID
    # @param id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(OperationOutput, Fixnum, Hash)>] OperationOutput data, response status code and response headers
    def operations_id_get_with_http_info(id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OperationsApi.operations_id_get ...'
      end
      # verify the required parameter 'id' is set
      if @api_client.config.client_side_validation && id.nil?
        fail ArgumentError, "Missing the required parameter 'id' when calling OperationsApi.operations_id_get"
      end
      # resource path
      local_var_path = '/operations/{id}'.sub('{' + 'id' + '}', id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'OperationOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OperationsApi#operations_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create a new Operation
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [OperationOutput]
    def operations_post(body, opts = {})
      data, _status_code, _headers = operations_post_with_http_info(body, opts)
      data
    end

    # Create a new Operation
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(OperationOutput, Fixnum, Hash)>] OperationOutput data, response status code and response headers
    def operations_post_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OperationsApi.operations_post ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling OperationsApi.operations_post"
      end
      # resource path
      local_var_path = '/operations'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = ['api_key']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'OperationOutput')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OperationsApi#operations_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
